/*!
 * scroll-watcher - v1.0.0
 * A lightweight, blazing fast, rAF based, scroll watcher.
 * https://github.com/jonataswalker/scroll-watcher
 * Built: Mon Nov 27 2017 15:29:04 GMT-0200 (-02)
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.ScrollWatcher=e()}(this,function(){"use strict";function t(){}function e(t,e){if(void 0===e&&(e="Assertion failed"),!t){if("undefined"!=typeof Error)throw new Error(e);throw e}}function n(t,e,n){void 0===e&&(e=window.document);let o=/\./g,i=Array.prototype.slice,r=[];if(/^(#?[\w-]+|\.[\w-.]+)$/.test(t))switch(t[0]){case"#":r=[function(t){return t="#"===t[0]?t.substr(1,t.length):t,document.getElementById(t)}(t.substr(1))];break;case".":r=i.call(e.getElementsByClassName(t.substr(1).replace(o," ")));break;default:r=i.call(e.getElementsByTagName(t))}else r=i.call(e.querySelectorAll(t));return n?r:r[0]}function o(t){let e;switch(function(t){return t===window&&t.document&&t.location?"window":t===document?"htmldocument":"string"==typeof t?"string":i(t)?"element":void 0}(t)){case"window":case"htmldocument":case"element":e=t;break;case"string":e=n("#"===t[0]||"."===t[0]?t:"#"+t);break;default:console.warn("Unknown type")}return e}function i(t){return"HTMLElement"in window?!!t&&t instanceof HTMLElement:!!t&&"object"==typeof t&&1===t.nodeType&&!!t.nodeName}function r(){return[window.pageXOffset||document.documentElement&&document.documentElement.scrollLeft||document.body.scrollLeft,window.pageYOffset||document.documentElement&&document.documentElement.scrollTop||document.body.scrollTop]}function s(){return{w:window.innerWidth||document.documentElement.clientWidth,h:window.innerHeight||document.documentElement.clientHeight}}function l(t){const e=t.getBoundingClientRect(),n=document.documentElement;return{left:e.left+window.pageXOffset-n.clientLeft,top:e.top+window.pageYOffset-n.clientTop,width:t.offsetWidth,height:t.offsetHeight}}function u(t){return{isInViewport:t.isInViewport,isFullyInViewport:t.isFullyInViewport,isAboveViewport:t.isAboveViewport,isBelowViewport:t.isBelowViewport,isPartialOut:t.isPartialOut,isFullyOut:t.isFullyOut}}t.prototype={on:function(t,e,n){var o=this.e||(this.e={});return(o[t]||(o[t]=[])).push({fn:e,ctx:n}),this},once:function(t,e,n){function o(){i.off(t,o),e.apply(n,arguments)}var i=this;return o._=e,this.on(t,o,n)},emit:function(t){var e=[].slice.call(arguments,1),n=((this.e||(this.e={}))[t]||[]).slice(),o=0,i=n.length;for(o;o<i;o++)n[o].fn.apply(n[o].ctx,e);return this},off:function(t,e){var n=this.e||(this.e={}),o=n[t],i=[];if(o&&e)for(var r=0,s=o.length;r<s;r++)o[r].fn!==e&&o[r].fn._!==e&&i.push(o[r]);return i.length?n[t]=i:delete n[t],this}};for(var a=t,c="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{},p=function(t,e){return e={exports:{}},t(e,e.exports),e.exports}(function(t){(function(){var e,n,o,i,r,s;"undefined"!=typeof performance&&null!==performance&&performance.now?t.exports=function(){return performance.now()}:"undefined"!=typeof process&&null!==process&&process.hrtime?(t.exports=function(){return(e()-r)/1e6},n=process.hrtime,i=(e=function(){var t;return 1e9*(t=n())[0]+t[1]})(),s=1e9*process.uptime(),r=i-s):Date.now?(t.exports=function(){return Date.now()-o},o=Date.now()):(t.exports=function(){return(new Date).getTime()-o},o=(new Date).getTime())}).call(c)}),f="undefined"==typeof window?c:window,w=["moz","webkit"],d="AnimationFrame",h=f["request"+d],m=f["cancel"+d]||f["cancelRequest"+d],y=0;!h&&y<w.length;y++)h=f[w[y]+"Request"+d],m=f[w[y]+"Cancel"+d]||f[w[y]+"CancelRequest"+d];if(!h||!m){var g=0,I=0,v=[];h=function(t){if(0===v.length){var e=p(),n=Math.max(0,1e3/60-(e-g));g=n+e,setTimeout(function(){var t=v.slice(0);v.length=0;for(var e=0;e<t.length;e++)if(!t[e].cancelled)try{t[e].callback(g)}catch(t){setTimeout(function(){throw t},0)}},Math.round(n))}return v.push({handle:++I,callback:t,cancelled:!1}),I},m=function(t){for(var e=0;e<v.length;e++)v[e].handle===t&&(v[e].cancelled=!0)}}var b=function(t){return h.call(f,t)};b.cancel=function(){m.apply(f,arguments)},b.polyfill=function(t){t||(t=f),t.requestAnimationFrame=h,t.cancelAnimationFrame=m};const V="page:load",O="scrolling",F="enter",E="enter:full",B="exit:partial",L="exit",x={top:0,bottom:0};var A=function(t){this.Base=t,this.lastXY=[],this.watching={},this.viewport=s(),this.loopBound=this.loop.bind(this),this.runLoop(),this.setListeners(),this.rafId=null};A.prototype.loop=function(){this.lastXY.join()!==r().join()?(this.handleItems(),this.runLoop()):this.runLoop()},A.prototype.handleItems=function(){var t=this;const e=this.getScrollData();this.Base.emit(O,e),Object.keys(this.watching).forEach(function(n){e.target=t.watching[n].node,t.recalculate(t.watching[n]),t.fireEvents(t.watching[n],e)})},A.prototype.fireEvents=function(t,e){t.isInViewport&&!t.wasInViewport&&(t.wasInViewport=!0,t.wasFullyOut=!1,t.emitter.emit(F,e)),t.isPartialOut&&!t.wasPartialOut&&(t.wasPartialOut=!0,t.wasFullyInViewport=!1,t.emitter.emit(B,e)),t.isFullyOut&&!t.wasFullyOut&&(t.wasFullyOut=!0,t.wasInViewport=!1,t.wasFullyInViewport=!1,t.emitter.emit(L,e)),t.isFullyInViewport&&!t.wasFullyInViewport&&(t.wasFullyInViewport=!0,t.wasPartialOut=!1,t.wasFullyOut=!1,t.emitter.emit(E,e))},A.prototype.getScrollData=function(){const t=r(),e=t[1]>this.lastXY[1];return this.lastXY=t,{scrollX:t[0],scrollY:t[1],scrollingDown:e,scrollingUp:!e}},A.prototype.stopLoop=function(){b.cancel(this.rafId)},A.prototype.runLoop=function(){this.rafId=b(this.loopBound)},A.prototype.recalculate=function(t){const e=t.dimensions.top+t.offset.top,n=t.dimensions.top+t.offset.bottom+t.dimensions.height,o=this.lastXY[1],i=this.lastXY[1]+this.viewport.h;t.isAboveViewport=e<o,t.isBelowViewport=n>i,t.isInViewport=e<=i&&n>o,t.isFullyInViewport=e>=o&&n<=i||t.isAboveViewport&&t.isBelowViewport,t.isFullyOut=!t.isInViewport&&t.wasInViewport,t.isPartialOut=t.wasFullyInViewport&&!t.isFullyInViewport&&!t.isFullyOut},A.prototype.setListeners=function(){const t=this;document.addEventListener("readystatechange",function e(n){if("undefined"!=typeof document)switch(document.readyState){case"loading":case"interactive":break;case"complete":t.Base.emit(V,{scrollX:t.lastXY[0],scrollY:t.lastXY[1]}),document.removeEventListener("readystatechange",e)}},!1),window.addEventListener("resize",function(e){t.viewport=s()},!1)};return function(t){function n(){if(!(this instanceof n))return new n;t.call(this),this.counter=0,n.Internal=new A(this)}return t&&(n.__proto__=t),n.prototype=Object.create(t&&t.prototype),n.prototype.constructor=n,n.prototype.watch=function(r,s){e("string"==typeof r||i(r),"@param `element` should be string type or DOM Element!"),e("number"==typeof s||"object"==typeof s||void 0===s,"@param `opt_offset` should be number or Object or undefined!");let a;const c=++this.counter,p=new t,f=o(r);return e(i(f),"Couldn't evaluate ("+r+") to a valid DOM node"),a="number"==typeof s?{top:s,bottom:s}:function(t,e){let n={};for(let e in t)n[e]=t[e];for(let t in e)n[t]=e[t];return n}(x,s),n.Internal.watching[c]={node:f,emitter:p,offset:a,dimensions:l(f)},function(t){t.isInViewport=!1,t.wasInViewport=!1,t.isAboveViewport=!1,t.wasAboveViewport=!1,t.isBelowViewport=!1,t.wasBelowViewport=!1,t.isPartialOut=!1,t.wasPartialOut=!1,t.isFullyOut=!1,t.wasFullyOut=!1,t.isFullyInViewport=!1,t.wasFullyInViewport=!1}(n.Internal.watching[c]),{target:f,props:u(n.Internal.watching[c]),update:function(){const t=n.Internal.watching[c],e=n.Internal.getScrollData();return e.target=t.node,n.Internal.stopLoop(),function(t){t.isInViewport=!1,t.isAboveViewport=!1,t.isBelowViewport=!1,t.isPartialOut=!1,t.isFullyOut=!1,t.isFullyInViewport=!1}(t),t.dimensions=l(f),n.Internal.recalculate(t),this.props=u(t),n.Internal.fireEvents(t,e),n.Internal.runLoop(),this},once:function(t,e){return p.once(t,e,this),this},on:function(t,e){return p.on(t,e,this),this},off:function(t,e){return p.off(t,e,this),this}}},n.prototype.windowAtBottom=function(t){void 0===t&&(t=0);const e=n.Internal.lastXY[1],o=n.Internal.viewport.h;return t=parseInt(t,10),e+o>=Math.max(document.body.scrollHeight,document.documentElement.scrollHeight,document.body.offsetHeight,document.documentElement.offsetHeight,document.documentElement.clientHeight)-t},n.prototype.windowAtTop=function(t){void 0===t&&(t=0);const e=n.Internal.lastXY[1];return t=parseInt(t,10),e<=t},n}(a)});
